routes/web.php
<?php


use App\Http\Controllers\Admin\UserControler;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::middleware(['auth:sanctum', 'verified'])->get('/dashboard', function () {
    return Inertia\Inertia::render('Dashboard');
})->name('dashboard');

Route::group(['prefix' => 'admin'],function (){

    Route::resource('users', 'Admin\UserControler')->except('show')->names('admin.users');

});

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Illuminate\Support\Facades\Hash;
use Laravel\Fortify\TwoFactorAuthenticatable;
use Laravel\Jetstream\HasProfilePhoto;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens;
    use HasFactory;
    use HasProfilePhoto;
    use Notifiable;
    use TwoFactorAuthenticatable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name',
        'email',
        'password',
        'avatar'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
        'two_factor_recovery_codes',
        'two_factor_secret',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    /**
     * The accessors to append to the model's array form.
     *
     * @var array
     */
    protected $appends = [
        'profile_photo_url',
    ];

}

app/Http/Controllers/Admin/UserControler.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\UserStoreRequest;
use App\Http\Requests\UserUpdateRequest as UserUpdateRequest;
use App\Models\User;
use App\Repositories\UserRepositories;


class UserControler extends Controller
{

    private $userRepositories;

    public function __construct()
    {

        $this->userRepositories = app(UserRepositories::class);
    }
    /**
     * Метод який виводить всіх юзерів з пагінацією 5 юзерів на одній сторінці
     *
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {

        $items = $this->userRepositories->getAllUser();

        return view('admin.user.index',compact('items'));
    }

    /**
     * Метод повіртає сторінку для створення нового юзера
     *
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {

        return view('admin.user.create');
    }

    /**
     * Метод додає юзера в базу даних хешує пароль і в випадку успіху редіректить на сторінку редагування
     *
     * @param UserStoreRequest $request
     * @return \Illuminate\Http\RedirectResponse
     */
    public function store(UserStoreRequest $request)
    {
        $data = $request->all();

        $item = User::create($data);


        if ($item)
        {
            return  redirect()->route('admin.users.edit',[$item->id])
                ->with(['success' => 'Create User']);
        }
        else
        {
            return back()->withErrors(['msd'=>'Error'])
                ->withInput();
        }
    }

    /**
     * Метод повертає сторінку редагування
     *
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */

    public function edit($id)
    {
        $items = $this->userRepositories->getEdit($id);
        if (empty($items))
        {
            abort(404);
        }

        return view('admin.user.edit',compact('items'));
    }


    /**
     *  Метод редагує запис в базі даних змінює пароль і якщо все пройшло успішно редіректись на сторінку редагування
     *
     * @param UserUpdateRequest $request
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     */
    public function update(UserUpdateRequest $request, $id)
    {
        $items = User::find($id);
        if (empty($items))
        {
            return back()
                ->withErrors(['msg' => "Юзер с ід={$id} не найдено"])
                ->withInput();
        }

        $data = $request->all();



        $result = $items->upDate($data);

        if ($result)
        {
            return redirect()
                ->route('admin.users.edit',$id)
                ->with(['success' => " Сохранено"]);
        }
        else
        {
            return back()
                ->withErrors(['msg' => "Error"])
                ->withInput();
        }
    }

    /**
     * Видаляє запис з бази даних якщо все добре редіректить на стронку редагування
     *
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $result = User::destroy($id);

        if ($result)
        {
            return redirect()
                ->route('admin.users.index',$id)
                ->with(['success' => "Удален юзер с id[$id] "]);
        }
        else
        {
            return back()
                ->withErrors(['msg' => "Error"]);

        }
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/View/Components/GuestLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class GuestLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.guest');
    }
}

resources/views/admin/user/create.blade.php
<x-guest-layout>
    <x-slot name="logo">

    </x-slot>


    <div class="container">
        @php /** @var \App\Models\User $items */ @endphp

        <h1>CRUD CREATE User</h1>

        @if($errors->any())
            @foreach($errors->all() as $error)
                <div class="alert alert-danger" role="alert">
                    {{ $error }}
                </div>
            @endforeach
        @endif

        @if(session('success'))
            <h2> {{session()->get('success')}} </h2>
        @endif
        <div class="col-lg-12 push-lg-4 personal-info">
            <form role="form" method="POST" action="{{ route('admin.users.store' ) }}" enctype="multipart/form-data">

                @csrf
                <div class="form-group row">
                    <label class="col-lg-3 col-form-label form-control-label">Avatar</label>
                    <div class="col-lg-9">
                        <div class="input-group mb-3">
                            <div class="input-group-prepend">
                                <span class="input-group-text">Upload</span>
                            </div>
                            <div class="custom-file">
                                <input type="file" name="avatar" class="custom-file-input" >
                                <label class="custom-file-label" for="inputGroupFile01">Choose file</label>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="form-group row">
                    <label class="col-lg-3 col-form-label form-control-label">Name</label>
                    <div class="col-lg-9">
                        <input class="form-control" name="name" value="{{old('name')}}" type="text" " />
                    </div>
                </div>
                <div class="form-group row">
                    <label class="col-lg-3 col-form-label form-control-label">email</label>
                    <div class="col-lg-9">
                        <input class="form-control" type="email" name="email" value="{{old('email')}}"   />
                    </div>
                </div>
                <div class="form-group row">
                    <label class="col-lg-3 col-form-label form-control-label">Password</label>
                    <div class="col-lg-9">
                        <input class="form-control" type="password" name="password"   />
                    </div>
                </div>


                <div class="form-group row">
                    <label class="col-lg-5 col-form-label form-control-label"></label>
                    <div class="col-lg-3">

                        <input type="submit" class="btn btn-primary" value="Create User" />
                    </div>
                </div>

            </form>
        </div>

    </div>


</x-guest-layout>

resources/views/admin/user/edit.blade.php
<x-guest-layout>
    <x-slot name="logo">

    </x-slot>
    <div class="container">
        @php /** @var \App\Models\User $items */ @endphp
        <h1>CRUD EDIT User [{{ $items->id }}]</h1>

        @if($errors->any())
            @foreach($errors->all() as $error)
                <div class="alert alert-danger" role="alert">
                    {{ $error }}
                </div>
            @endforeach
        @endif

        @if(session('success'))
            <div class="alert alert-primary" role="alert">
                {{session()->get('success')}}
            </div>
        @endif
        <div class="col-lg-12 push-lg-4 personal-info">
            <form role="form" method="POST" action="{{ route('admin.users.update', $items->id ) }}" enctype="multipart/form-data">
                @method('PATCH')
                @csrf
                <div class="form-group row">
                    <label class="col-lg-3 col-form-label form-control-label">Avatar</label>
                    @if($items->avatar)
                        <div class="card" style="width: 18rem;">
                            <img class="card-img-top" src="{{ asset($items->avatar) }}" alt="Card image cap">

                        </div>
                    @endif
                    <div class="col-lg-9">
                        <div class="input-group mb-3">
                            <div class="input-group-prepend">
                                <span class="input-group-text">Upload</span>
                            </div>
                            <div class="custom-file">
                                <input type="file" name="avatar" class="custom-file-input" >
                                <label class="custom-file-label" for="inputGroupFile01">Choose file</label>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="form-group row">
                    <label class="col-lg-3 col-form-label form-control-label">Name</label>
                    <div class="col-lg-9">
                        <input class="form-control" name="name" type="text" value="{{old('name',$items->name)}}" />
                    </div>
                </div>
                <div class="form-group row">
                    <label class="col-lg-3 col-form-label form-control-label">Email</label>
                    <div class="col-lg-9">
                        <input class="form-control" type="email" name="email" value="{{old('email',$items->email)}}" />
                    </div>
                </div>
                <div class="form-group row">
                    <label class="col-lg-3 col-form-label form-control-label">Reset Password</label>
                    <div class="col-lg-9">
                        <input class="form-control" type="password" name="password" " />
                    </div>
                </div>


                <div class="form-group row">
                    <label class="col-lg-5 col-form-label form-control-label"></label>
                    <div class="col-lg-3">

                        <input type="submit" class="btn btn-primary" value="Save Changes" />
                    </div>
                </div>

            </form>
        </div>

    </div>

</x-guest-layout>

resources/views/admin/user/index.blade.php
<x-guest-layout>
    <x-slot name="logo">

    </x-slot>

            <div class="container">
                @if($errors->any())
                    @foreach($errors->all() as $error)
                        <div class="alert alert-danger" role="alert">
                            {{ $error }}
                        </div>
                    @endforeach
                @endif
                @if(session('success'))
                        <div class="alert alert-primary" role="alert">
                            {{session()->get('success')}}
                        </div>
                @endif
                <nav class="navbar navbar-toggleable-md navbar-light bg-faded">

                    <a class="btn btn-primary" role="button" href="{{ route('admin.users.create') }}">Add</a>


                </nav>
                    <div class="row justify-content-center">
                        <div class="col-md-12">

                            <div class="card">
                                <div class="card-body">
                                    <table class="table table-hover">
                                        <thead>
                                        <tr>
                                            <th>#</th>
                                            <th>name</th>
                                            <th>email</th>
                                            <th>opinions</th>
                                        </tr>
                                        </thead>
                                        <tbody>
                                        @foreach($items as $user)

                                            @php /** @var \App\Models\User $user */ @endphp
                                            <tr>
                                                <td>

                                                    {{ $user->id }}

                                                </td>
                                                <td>
                                                    <a href="{{ route('admin.users.edit',$user->id ) }}">
                                                        {{ $user->name }}
                                                    </a>
                                                </td>
                                                <td>{{ $user->email }}</td>
                                                <td>
                                                    <form method="POST" action="{{ route('admin.users.destroy',$user->id) }}">
                                                        @method('DELETE')
                                                        @csrf
                                                        <button type="submit" class="btn btn-danger" >Delete</button>
                                                    </form>
                                                </td>
                                            </tr>
                                        @endforeach
                                        </tbody>


                                    </table>
                                </div>
                            </div>


                        </div>
                    </div>


                        @if($items->total() > $items->count())
                            <div class="row">
                                  <div class="col-md-12">
                                    <div class="card">
                                        <div class="card-body">
                                            {{ $items->links() }}
                                        </div>
                                    </div>
                                  </div>
                            </div>
                        @endif
            </div>
</x-guest-layout>

resources/views/app.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="csrf-token" content="{{ csrf_token() }}">

        <title>{{ config('app.name', 'Laravel') }}</title>

        <!-- Fonts -->
        <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Nunito:wght@400;600;700&display=swap">

        <!-- Styles -->
        <link rel="stylesheet" href="{{ mix('css/app.css') }}">

        <!-- Scripts -->
        @routes
        <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.26.0/moment.min.js"></script>
        <script src="{{ mix('js/app.js') }}" defer></script>
    </head>
    <body class="font-sans antialiased">
        @inertia
    </body>
</html>

resources/views/layouts/guest.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="csrf-token" content="{{ csrf_token() }}">

        <title>{{ config('app.name', 'Laravel') }}</title>

        <!-- Fonts -->
        <link rel="stylesheet" href="https://fonts.googleapis.com/css2?family=Nunito:wght@400;600;700&display=swap">

        <!-- Styles -->
        <link rel="stylesheet" href="{{ asset('css/app.css') }}">

        <!-- Scripts -->
        <script src="https://cdn.jsdelivr.net/gh/alpinejs/alpine@v2.7.3/dist/alpine.js" defer></script>
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css" integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" crossorigin="anonymous">
    </head>
    <body>
        <div class="font-sans text-gray-900 antialiased">
            {{ $slot }}
        </div>
        <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ho+j7jyWK8fNQe+A12Hb8AhRq26LrZ/JpcUGGOn+Y7RsweNrtN/tE3MoK7ZeZDyx" crossorigin="anonymous"></script>
    </body>
</html>